wok-6.x view syslinux/stuff/iso2exe/taziso @ rev 18240

syslinux/taziso: do not use /media/cdrom
author Pascal Bellard <pascal.bellard@slitaz.org>
date Tue Jul 28 08:46:03 2015 +0200 (2015-07-28)
parents 87cb419b692f
children db66c997923a
line source
1 #!/bin/sh
3 [ $(id -u) -eq 0 ] || exec su -c "$0 $@"
5 DIALOG=dialog
7 ddq()
8 {
9 dd $@ 2> /dev/null
10 }
12 get()
13 {
14 od -v -j $1 -N ${4:-${3:-2}} -t u${3:-2} -w${3:-2} -An $2 2>/dev/null ||
15 hexdump -v -s $1 -n ${4:-${3:-2}} -e "\"\" 1/${3:-2} \" %d\n\"" $2
16 }
18 bytes2bin()
19 {
20 for i in $@ ; do
21 printf '\\\\x%02X' $(($i&255))
22 done | xargs echo -en
23 }
25 words2bin()
26 {
27 for i in $@ ; do
28 printf '\\\\x%02X\\\\x%02X' $(($i&255)) $((($i>>8)&255))
29 done | xargs echo -en
30 }
32 gettazboot()
33 {
34 echo "Creating $(basename $1) ..."
35 O=$(($(get 64 $ISO) - 0xC0))
36 L=$(($(get 20 $ISO) - 0xC0 - $(get 24 $ISO) - $O))
37 S=$((32+$L))
38 P=$((($S+511)/512))
39 E=$((4096-(32*$P)))
40 words2bin 0x5A4D $(($S%512)) $P 0 2 $E -1 $((${2:-0}-16)) \
41 -2 0 256 -16 28 0x6C53 0x5469 0x7A61 > $1
42 ddq bs=1 count=$L skip=$(echo $O) if=$ISO >> $1
43 }
45 uncpio()
46 {
47 [ -s "$1" ] || return
48 echo -en "\n Extracting $(basename $1) ..."
49 case $(get 0 $1) in
50 *35615) ( zcat || gunzip ) ;;
51 *14333) unxz ;;
52 *\ 93) unlzma ;;
53 *) cat ;;
54 esac < $1 | ( cd ${2:-/} ; cpio -idmu > /dev/null 2>&1 )
55 }
57 dotwait()
58 {
59 echo -n "${1:-Install filesystem}.."
60 touch /tmp/wait
61 [ "$REQUEST_URI" ] && return
62 while [ -e /tmp/wait ]; do
63 echo -n "." > /dev/tty
64 sleep 1
65 done &
66 }
68 getuuid()
69 {
70 dev=$(mount | sed "/ $(echo $mnt | sed 's|/|\\/|g') /!d;s/ .*//;s|/dev/||;q")
71 [ "$dev" ] &&
72 blkid | sed "/$dev:/!d;s/.* UUID=.\\([^ ]*\\)\".*/\\1/" ||
73 echo "/dev/hda1"
74 }
76 tazusbinitfs()
77 {
78 PAD=$(($(stat -c %s $1) % 4))
79 [ $PAD -ne 0 ] && ddq if=/dev/zero bs=1 count=$((4 - $PAD)) >> $1
80 mkdir -p /tmp/fs$$/etc /tmp/fs$$/lib /tmp/fs$$/home
81 cp -a /etc/locale.conf /tmp/fs$$/etc 2> /dev/null
82 cp -a /etc/keymap.conf /tmp/fs$$/etc 2> /dev/null
83 cat > /tmp/fs$$/init1 <<EOT
84 #!/bin/sh
85 sed -i 's|sbin/init|init2|' /init
86 exec /init
87 EOT
88 cat > /tmp/fs$$/init2 <<EOT
89 #!/bin/sh
91 mount -t proc /proc /proc
92 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
93 v=\$(sed '/\\/home=/!d;s|.*/home=\\([^ ]*\\).*|\\1|' /proc/cmdline /cmdline 2> /dev/null)
94 mount / -o remount,rw
95 mkdir /mnt/dos
96 rm -f /cmdline 2> /dev/null
97 mount / -o remount,ro
98 mnt=/mnt/dos/\${v#*/}
99 dev=\$( (blkid /dev/[sh]d* || blkid) | grep \${v%%/*} | sed 's/:.*//;q')
100 echo "Mount \$dev in /mnt/dos for \$v..." | tee -a /run/boot.log
101 mount \$dev /mnt/dos
102 if [ ! -d /mnt/dos/slitaz ]; then
103 umount /mnt/dos 2> /dev/null
104 (blkid /dev/[sh]d* || blkid) | while read dev line; do
105 case "\$line" in
106 *ntfs*|*vfat*|*msdos*) ;;
107 *) continue ;;
108 esac
109 mount \${dev%:} /mnt/dos
110 [ -d /mnt/dos/slitaz ] && break
111 umount /mnt/dos
112 done
113 fi
114 $([ "$2" ] || echo '# ')mount.posixovl -F \$mnt -- -oallow_other -odefault_permissions -osuid
115 mount --bind \$mnt /home
116 umount /proc
117 exec /sbin/init
118 EOT
119 chmod 755 /tmp/fs$$/init?
120 ( cd /tmp/fs$$ ; find * | cpio -o -H newc ) | gzip -9 >> $1
121 rm -rf /tmp/fs$$
122 }
124 mkinitrd()
125 {
126 echo -en "\nCreating $(basename $1) "
127 fs=/tmp/fs$$
128 for i in bin lib dev proc tmp mnt etc ; do
129 mkdir -p $fs/$i
130 done
131 for i in /dev/console /dev/null /dev/tty /dev/tty0 /dev/tty1 /dev/tty2 \
132 /dev/fuse /dev/hd* /dev/sd* ; do
133 cp -a $2$i $fs/dev/
134 done
135 for i in /bin/busybox $(which mount.posixovl) $(which blkid); do
136 cp $(LD_TRACE_LOADED_OBJECTS=1 /lib/ld*.so $i | \
137 sed 's|.*=> \(.*/lib/l[^ ]*\).*|\1|;/^\//!d') $fs/lib
138 cp $i $fs/bin
139 done
140 cp -a /lib/ld-* $fs/lib
141 for i in $(busybox | sed '/Current/,$!d'); do
142 [ -e $fs/bin/${i%,} ] || ln -s busybox $fs/bin/${i%,}
143 done
144 ln -s /proc/mounts $fs/etc/mtab
145 sed 's/ .*//' /proc/modules | while read mod ; do
146 find /lib/modules/ | grep $mod.ko | \
147 sed 's|.*|cp & $fs/lib|' | sh
148 done
149 cat > $fs/init <<EOT
150 #!/bin/sh
152 arg()
153 {
154 grep -q \$1 /proc/cmdline &&
155 val="\$(sed "s/.*\$1=\\([^ ]*\\).*/\\1/" < /proc/cmdline)" &&
156 echo "\$2 \$val"
157 }
159 mount -t proc /proc /proc
160 arg debug "shell" && debug=true && set -x
161 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
162 arg mount "Mount device"
163 mount \$( (blkid /dev/[sh]d* || blkid) | grep \$val | sed 's/:.*//;q') /mnt
164 arg subroot "Change root to directory"
165 if [ -d /mnt/\$val ]; then
166 umount /mnt 2> /dev/null
167 (blkid /dev/[sh]d* || blkid) | while read dev line; do
168 case "\$line" in
169 *ntfs*|*vfat*|*msdos*) ;;
170 *) continue ;;
171 esac
172 mount \${dev%:} /mnt
173 [ -d /mnt/\$val ] && break
174 umount /mnt
175 done
176 fi
177 $([ "$3" ] || echo '# ')mount.posixovl -F /mnt/\$val -- -oallow_other -odefault_permissions -osuid
178 mount --bind /mnt /mnt/\$val/mnt/dos
179 mount -o size=0 -t tmpfs tmpfs /mnt/\$val/mnt/dos/\$val
180 LDSO=\$(ls /mnt/\$val/lib/ld-* | sed q)
181 export LD_LIBRARY_PATH=\$val/lib:\$val/usr/lib:/lib
182 [ "$debug" = "true" ] && sh
183 umount /proc
184 exec /bin/switch_root /mnt \${LDSO#/mnt/} \$val/usr/sbin/chroot \$val /sbin/init
185 EOT
186 chmod +x $fs/init
187 ( cd $fs ; find * | cpio -o -H newc ) | lzma e $1 -si 2> /dev/null
188 rm -rf $fs /tmp/wait
189 }
191 ls_r()
192 {
193 ls -r $@ 2> /dev/null || ls $@
194 }
196 doinstall()
197 {
198 unset useposixovl
199 blkid | grep $(df $mnt | sed '$!d;s/ .*/:/') | \
200 grep -qiE "(msdos|vfat|ntfs)" && useposixovl=YES
202 mkdir -p $mnt/slitaz/boot $mnt/slitaz/mnt/dos
203 [ "$useposixovl" ] &&
204 if ! mount.posixovl -F $mnt/slitaz -- \
205 -oallow_other -odefault_permissions -osuid; then
206 echo "Can't install SliTaz. Abort."
207 sleep 5
208 return 1
209 fi
210 dotwait "Install root filesystem in /slitaz.."
211 if [ "$1" ]; then
212 ls_r $media/boot/rootfs*gz | \
213 xargs cat > $mnt/slitaz/boot/rootfs.gz
214 tazusbinitfs $mnt/slitaz/boot/rootfs.gz $useposixovl
215 initrd=rootfs.gz
216 extraargs="/home=$(getuuid)/slitaz rdinit=/init1"
217 else
218 for i in $(ls_r $media/boot/rootfs*gz); do
219 uncpio $i $mnt/slitaz
220 done
221 for i in $packages_list; do
222 tazpkg get-install $i --root=$mnt/slitaz
223 done
224 for i in $packages_dir/*.tazpkg; do
225 [ -s "$i" ] &&
226 tazpkg install $i --root=$mnt/slitaz
227 done
228 cp -a /etc/locale.conf $mnt/slitaz/etc 2> /dev/null
229 cp -a /etc/keymap.conf $mnt/slitaz/etc 2> /dev/null
230 mkinitrd $mnt/slitaz/boot/initrd $mnt/slitaz $useposixovl
231 initrd=initrd
232 extraargs="mount=$(getuuid) subroot=slitaz"
233 fi
234 echo -en "\nInstall boot files..."
235 for i in $media/boot/bzImage $media/boot/*pxe* \
236 $media/boot/isolinux/he* $media/boot/isolinux/opt* \
237 $media/README $media/boot/memtest* ; do
238 [ -s $i ] && cp $i $mnt/slitaz/boot
239 done
240 for i in $mnt/slitaz/boot/memtest $mnt/slitaz/boot/*pxe* ; do
241 [ $(get 0 $i 2> /dev/null || echo 0) -eq 23117 ] &&
242 mv $i $i.exe
243 done
244 gettazboot $mnt/slitaz/boot/tazboot.exe
245 unix2dos > $mnt/slitaz/boot/tazboot.cmd <<EOT
246 kernel=/slitaz/boot/bzimage
247 initrd=/slitaz/boot/$initrd
248 rw root=/dev/null $extraargs autologin
249 EOT
250 unix2dos $mnt/slitaz/boot/he* $mnt/slitaz/boot/opt* \
251 $mnt/slitaz/boot/README
252 [ -d $mnt/slitaz/usr/sbin -a ! -x $mnt/slitaz/usr/sbin/mount.posixovl ] &&
253 cp $(which mount.posixovl) $mnt/slitaz/usr/sbin
254 if "$useposixovl" && grep -qs " $mnt " /proc/mounts &&
255 [ ! -d $mnt/boot/grub ]; then
256 mkdir -p $mnt/boot/grub
257 echo -en "\nInstall grub in /boot/grub..."
258 cp -a /usr/lib/grub/*/* $mnt/boot/grub
259 cat > $mnt/boot/grub/menu.lst <<EOT
260 # /boot/grub/menu.lst: GRUB boot loader configuration.
262 # By default, boot the first entry.
263 default 0
265 # Boot automatically after 8 secs.
266 timeout 8
268 title Microsoft Windows
269 chainloader +1
271 EOT
272 dev=$(grep " $mnt " /proc/mounts | awk '{ print $1 }')
273 base=${dev//[0-9]/}
274 dd if=$base bs=32k count=1 of=$mnt/boot/grub/$(basename $base)
275 cat > $mnt/boot/grub/uninstall-grub.sh <<EOT
276 #!/bin/sh
278 [ -s /boot/grub/$(basename $base) ] &&
279 dd if=/boot/grub/$(basename $base) of=$base
280 EOT
281 grub-install --no-floppy --root-directory=$mnt $base
282 fi
283 if [ -s $mnt/boot/grub/menu.lst ] &&
284 ! grep -q /slitaz/boot/bzimage $mnt/boot/grub/menu.lst; then
285 echo -en "\nUpdate /boot/grub/menu/lst..."
286 cat >> $mnt/boot/grub/menu.lst <<EOT
287 title SliTaz GNU/Linux $(cat $mnt/slitaz/etc/slitaz-release)
288 kernel /slitaz/boot/bzimage rw root=/dev/null $extraargs autologin
289 initrd /slitaz/boot/$initrd
291 EOT
292 fi
293 rm -f /tmp/wait
294 [ "$useposixovl" ] && umount $mnt/slitaz
295 return 0
296 }
298 windev()
299 {
300 if [ -b "$1" ]; then
301 device=$1
302 elif [ "$1" ]; then
303 echo "Invalid Linux/Windows partition"
304 return 1
305 else
306 DEV="$(blkid | grep -iE "(msdos|vfat|ntfs|ext[234]|xfs|btrfs)" | sed 's/:.*//;s|/dev/||')"
307 [ "$DEV" ] || return
308 cat > /tmp/dialog$$ <<EOT
309 $DIALOG --clear \
310 --title " Select your Linux/Windows partition " \
311 --menu "\nPlease select the Linux/Windows partition according to its known size.
312 The data will be kept untouched.\n" \
313 17 70 8 \
314 $(for i in $DEV ; do
315 label="$(blkid | sed "/$i:/!d;s/.*://;s/[^ ]*UUID=[^ ]* //g;s/LABEL=//")"
316 echo -n "/dev/$i \"$(($(cat /sys/block/*/$i/size)/2048))MB $label\" "
317 done)
318 EOT
319 exec 3>&1
320 [ $? -eq 0 ] || return
321 device=$(. /tmp/dialog$$ 2>&1 1>&3)
322 exec 3>&-
323 rm -f /tmp/dialog$$
324 fi
325 mnt=/tmp/mnt$$
326 mkdir -p $mnt && mount $device $mnt
327 }
329 extra_packages()
330 {
331 packages_list=
332 packages_dir=
333 $DIALOG --clear \
334 --title " Extra packages " \
335 --defaultno --yesno \
336 "
337 Do you want to add extra packages ?
338 " 7 70
339 [ $? -eq 0 ] || return
340 [ -s /var/lib/tazpkg/packages.txt ] || tazpkg recharge
341 if [ -s $media/boot/vmlinuz-$(uname -r) ]; then
342 cat > /tmp/dialog$$ <<EOT
343 $DIALOG --clear \
344 --title " Select the packages " \
345 --separate-output \
346 --cancel-label "Skip" \
347 --checklist "Please select the packages you want to install. Try with the first letter." \
348 0 0 0 \\
349 EOT
350 awk -F\| '{ printf "%s \"%s\" off ",$1,$3 }' \
351 /var/lib/tazpkg/packages.desc >> /tmp/dialog$$
352 sh /tmp/dialog$$ 2> /tmp/dialog.out$$
353 [ $? -eq 0 ] && packages_list="$(cat /tmp/dialog.out$$)"
354 fi
355 cat > /tmp/dialog$$ <<EOT
356 $DIALOG --clear \
357 --title "Please select the directory with every custom package to install." \
358 --cancel-label "Skip" \
359 --dselect $PWD 13 78
360 EOT
361 sh /tmp/dialog$$ 2> /tmp/dialog.out$$
362 [ $? -eq 0 ] && packages_dir="$(cat /tmp/dialog.out$$)"
363 rm -f /tmp/dialog$$ /tmp/dialog.out$$
364 }
366 _install()
367 {
368 extra_packages
369 $DIALOG --clear \
370 --title " SliTaz UMSDOS way installation " \
371 --yes-label "Install" --yesno \
372 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
373 Linux/DOS/Windows partition. You can see your files from /mnt/dos.\n\n
374 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
375 To uninstall SliTaz, you have only to remove this directory.
376 The file \\boot.ini or \\config.sys may be modified too.\n\n
377 SliTaz may run slowly on 'UMSDOS way' installation due to the
378 posixovl filesystem. The 'TAZUSB way' installation runs faster.\n\n
379 To do a traditional installation with disk partitioning,
380 start SliTaz Live with 'SliTaz RAM boot' menu.\n
381 " 19 70
382 [ $? -eq 0 ] || return
383 doinstall
384 }
386 readtazbootconf()
387 {
388 kernel="$(sed '/^kernel=/!d;s/.*=//' $mnt/slitaz/boot/tazboot.cmd)"
389 initrd="$(sed '/^initrd=/!d;s/.*=//' $mnt/slitaz/boot/tazboot.cmd)"
390 cmdline="$(sed '/^kernel=/d;/^initrd=/d' $mnt/slitaz/boot/tazboot.cmd)"
391 }
393 bootinstalled()
394 {
395 [ "$(which kexec)" ] || return
396 [ -x $mnt/slitaz$1 ] || return
397 [ -s $mnt/slitaz/boot/tazboot.cmd ] || return
398 readtazbootconf
399 kexec -l $kernel --initrd $initrd --command-line "$cmdline" || return
400 umount $mnt
401 rm -rf $mnt
402 quit "kexec -e"
403 }
405 mkzip()
406 {
407 device=
408 packages_list=
409 packages_dir=
410 mnt=/tmp/mnt$$
411 mkdir -p $mnt
412 $1 $2 || return
413 for i in bootlace.com grubinst.exe grldr ; do
414 wget -O $mnt/slitaz/boot/$i http://mirror.slitaz.org/boot/$i
415 done
416 readtazbootconf
417 cat > $mnt/slitaz/boot/menu.lst <<EOT
418 title SliTaz
419 kernel $kernel $cmdline
420 initrd $initrd
422 EOT
423 while read file title; do
424 file=$(ls $mnt/slitaz/boot/*$file* 2> /dev/null)
425 [ -s "$file" ] && cat >> $mnt/slitaz/boot/menu.lst <<EOT
426 title $title
427 kernel ${file#$mnt}
429 EOT
430 done <<EOT
431 memtest MemTest
432 pxe Web boot
433 EOT
434 unix2dos $mnt/slitaz/boot/menu.lst
435 unix2dos > $mnt/slitaz/boot/install.txt <<EOT
436 For DOS users (real mode only):
438 Start SliTaz with \\slitaz\\boot\\tazboot.exe
441 For NT/2000/XP users:
443 1- Move the files grldr and menu.lst into the root directory
445 C:\\> copy \\slitaz\\boot\\grldr \\
446 C:\\> copy \\slitaz\\boot\\menu.lst \\
448 2- Remove boot.ini attributes
450 C:\\> attrib -r -h -s boot.ini
452 3- Append the following line to boot.init
454 C:\\grldr="slitaz"
456 4- Restore boot.ini attributes
458 C:\\> attrib +r +h +s boot.ini
460 See http://diddy.boot-land.net/grub4dos/files/README_GRUB4DOS.txt
461 and http://xpt.sourceforge.net/techdocs/nix/disk/boot/boot07-GrubForDosInfo/ar01s03.html
462 EOT
463 ( cd $mnt ; echo 'See \slitaz\boot\install.txt to launch SliTaz.' | \
464 zip -zr9 $(basename $ISO .iso).zip slitaz )
465 [ "$(which advzip)" ] && advzip -z4 $mnt/*.zip
466 mv $mnt/*.zip .
467 ls -l $PWD/$(basename $ISO .iso).zip
468 umount $mnt
469 rm -rf $mnt
470 }
472 install()
473 {
474 windev $1 || return
475 packages_list=
476 packages_dir=
477 if [ "$1" ]; then
478 doinstall
479 else
480 _install && bootinstalled /sbin/init
481 fi
482 umount $mnt
483 rm -rf $mnt
484 }
486 inst2zip()
487 {
488 if [ "$1" ]; then
489 mkzip doinstall
490 else
491 mkzip _install
492 fi
493 }
495 _installtaz()
496 {
497 $DIALOG --clear \
498 --title " SliTaz TAZUSB way installation " \
499 --yes-label "Install" --yesno \
500 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
501 Linux/DOS/Windows partition. You can see your files from /mnt/dos.\n\n
502 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
503 To uninstall SliTaz, you have only to remove this directory.
504 The file \\boot.ini or \\config.sys may be modified too.\n\n
505 The filesystem is loaded entirely into memory upon boot to
506 increase responsiveness. Only /home lands on hard disk.\n\n
507 To do a traditional installation with disk partitioning,
508 start SliTaz Live with 'SliTaz RAM boot' menu.\n
509 " 19 70
510 [ $? -eq 0 ] || return
511 doinstall tazusblike
512 }
514 installtaz()
515 {
516 windev $1 || return
517 packages_list=
518 packages_dir=
519 if [ "$1" ]; then
520 doinstall tazusblike
521 else
522 _installtaz && bootinstalled /boot/bzimage
523 fi
524 umount $mnt
525 rm -rf $mnt
526 }
528 insttaz2zip()
529 {
530 if [ "$1" ]; then
531 mkzip doinstall tazusblike
532 else
533 mkzip _installtaz
534 fi
535 }
537 bootiso()
538 {
539 for i in $(ls_r $media/boot/rootfs*gz); do
540 grep -q ' lm ' /proc/cpuinfo && [ -s ${i}64 ] && i=${i}64
541 cat $i
542 n=$((4 - ($(stat -c %s $i) % 4)))
543 [ $n -eq 4 ] || dd if=/dev/zero bs=1 count=$n
544 done > /tmp/initrd$$
545 kernel=$media/boot/bzImage
546 grep -q ' lm ' /proc/cpuinfo && [ -s ${kernel}64 ] && kernel=${kernel}64
547 . /etc/locale.conf
548 kexec -l $kernel --initrd /tmp/initrd$$ --command-line \
549 "root=/dev/null autologin lang=$LANG kmap=$(cat /etc/keymap.conf)" &&
550 rm -f /tmp/initrd$$
551 quit "kexec -e"
552 }
554 tazboot()
555 {
556 if [ -z "$1" ]; then
557 $DIALOG --clear \
558 --title " SliTaz bootloader for DOS " \
559 --yes-label "Install" --yesno \
560 "\nThe file TAZBOOT.EXE will be created in the top directory. It supports
561 any linux kernel, multiple initramfs, a kernel command line and
562 an ISO image file loopback (retrieves files from an ISO file).\n\n
563 Usage: tazboot.exe [[@commands]|[kernel=<bzimage>]
564 [initrd=<rootfs>[,<rootfs2>...]] [bootfrom=<isofile>] cmdline args ...]\n\n
565 Defaults: tazboot @tazboot.cmd or tazboot kernel=bzImage auto\n\n\
566 Examples for tazboot.cmd:\n\n\
567 bootfrom=\\isos\\slitaz-4.0.iso\n\
568 kernel=boot/bzImage\n\
569 initrd=boot/rootfs4.gz,boot/rootfs3.gz,boot/rootfs2.gz,boot/rootfs1.gz\n\
570 rw root=/dev/null autologin\n\n\
571 kernel=\\slitaz\\vmlinuz root=/dev/sda5 ro\n\n
572 Unlike GRUB4DOS, it doesn't require unfragmented ISO image files.\n
573 " 0 0
574 [ $? -eq 0 ] || return
575 fi
576 gettazboot tazboot.exe
577 ls -l $PWD/tazboot.exe
578 }
580 md5()
581 {
582 dotwait "Checking files"
583 ( cd $media ; ${md5sum:-md5sum -c md5sum*} | sort ) > /tmp/data
584 unset md5sum
585 rm -f /tmp/wait
586 if [ "$1" ]; then
587 cat /tmp/data
588 else
589 $DIALOG --clear \
590 --title " Checked files " \
591 --textbox /tmp/data 0 0
592 fi
593 rm -f /tmp/data
594 }
596 gotcdfile()
597 {
598 for i in "$media/$1" "$media/*/$1" "$media/*/isolinux/$1" ; do
599 file=$(ls $i 2> /dev/null | sed q)
600 [ -s "$file" ] && break
601 done
602 }
604 sha()
605 {
606 gotcdfile 'sha*sum*'
607 sha=$(basename $file)
608 md5sum="${sha%sum*}sum -c ${file#$media/}"
609 md5 $@
610 }
612 readme()
613 {
614 gotcdfile 'README*'
615 if [ "$1" ]; then
616 cat $file
617 else
618 $DIALOG --clear \
619 --title " Readme " \
620 --textbox $file 0 0
621 fi
622 }
624 bzimage()
625 {
626 if [ -z "$1" ]; then
627 $DIALOG --clear \
628 --title " Create linux.exe ? " \
629 --yes-label "Install" --yesno \
630 "\nLinux.exe launches the linux kernel under DOS (in real mode only).
631 The cmdline arguments are supported except initrd=,
632 vga= (you can try 'rdev -v') and mem= (partially).
633 \nExample:\nC:\\> linux.exe root=/dev/hda2 ro panic=60\n
634 " 12 70
635 [ $? -eq 0 ] || return
636 fi
637 cp $media/boot/bzImage linux.exe
638 ls -l $PWD/linux.exe
639 }
641 memtest()
642 {
643 if [ -z "$1" ]; then
644 $DIALOG --clear \
645 --title " Create memtest.exe ? " \
646 --yes-label "Install" --yesno \
647 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
648 computers. BIOS based memory tests are a quick, cursory check and often
649 miss many of the failures that are detected by Memtest86.\n
650 " 0 0
651 [ $? -eq 0 ] || return
652 fi
653 gotcdfile 'memtest*' && cp $file memtest.exe
654 ls -l $PWD/memtest.exe
655 }
657 mkfat12()
658 {
659 [ $(($(get 0 $1) - 0x5A4D)) -eq 0 ] || return
660 J=$(($(get 3 $1 1) + 0x02))
661 R=$((1 + $(get 497 $1 1) + 1 + ($(get 500 $1)-1)/32))
662 [ $R -lt 2500 ] || return
663 [ $((($(get 500 $1)-1) & 31)) -lt 30 ] &&
664 ddq if=$file bs=32 count=1 seek=$(($R*16 - 1)) of=/dev/fd0
665 G="18 0 2 0 0 0 0 0"
666 [ $J -gt 25 ] || G=""
667 F=0
668 for i in 1 2 3; do
669 F=$((((2880-$R-$F-$F)*3+1023)/1024))
670 done
671 bytes2bin 0xEB $J 0x90 0x20 0x20 0x20 0x20 0x20 0x20 0x20 0x20 \
672 0 2 2 $(($R%256)) $(($R/256)) 2 64 0 64 11 0xF0 $F 0 \
673 $G | ddq bs=1 of=/dev/fd0
674 ddq if=/dev/zero bs=512 count=$((4+$F+$F)) seek=$R of=/dev/fd0
675 for i in $R $(($R+$F)) ; do
676 bytes2bin 0xF0 0xFF 0xFF | ddq bs=512 seek=$i of=/dev/fd0
677 done
678 echo -n $(basename $1) | ddq bs=1 seek=3 count=8 of=/dev/fd0
679 }
681 mkfloppy()
682 {
683 dotwait "Create a $(basename $1) boot floppy"
684 ddq if=$1 of=/dev/fd0
685 mkfat12 $1
686 rm -f /tmp/wait
687 }
689 fdmemtest()
690 {
691 if [ -z "$1" ]; then
692 $DIALOG --clear \
693 --title " Create a Memtest86 boot floppy " \
694 --yes-label "Create floppy" --yesno \
695 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
696 computers. BIOS based memory tests are a quick, cursory check and often
697 miss many of the failures that are detected by Memtest86.\n\n
698 Please insert a blank disk in floppy drive.\n
699 " 0 0
700 [ $? -eq 0 ] || return
701 fi
702 gotcdfile 'memtest*' && mkfloppy $file
703 }
705 pxe()
706 {
707 gotcdfile '?pxe'
708 if [ -z "$1" ]; then
709 $DIALOG --clear \
710 --title " Create $(basename $file).exe ? " \
711 --yes-label "Install" --yesno \
712 "\nBoot your operating system from the internet and enjoy a full system
713 working entirely in RAM with speed and stability in mind. The Linux Kernel
714 and the complete SliTaz compressed root filesystem will be loaded into RAM
715 from the Web using PXE and HTTP protocols.\n
716 " 0 0
717 [ $? -eq 0 ] || return
718 fi
719 cp $file $(basename $file).exe
720 ls -l $PWD/$(basename $file).exe
721 }
723 fdpxe()
724 {
725 if [ -z "$1" ]; then
726 $DIALOG --clear \
727 --title " Create a SliTaz Web boot floppy " \
728 --yes-label "Create floppy" --yesno \
729 "\nBoot your operating system from the internet and enjoy a full system
730 working entirely in RAM with speed and stability in mind. The Linux Kernel
731 and the complete SliTaz compressed root filesystem will be loaded into RAM
732 from the Web using PXE and HTTP protocols.\n\n
733 Please insert a blank disk in floppy drive.\n
734 " 0 0
735 [ $? -eq 0 ] || return
736 fi
737 gotcdfile '?pxe' && mkfloppy $file
738 }
740 menuitem()
741 {
742 [ "$3" ] && shift
743 echo -en "\"$1\" \"$2\""
744 }
746 gotposixovl()
747 {
748 mount.posixovl 2>&1 | grep -qi usage && menuitem "$@"
749 }
751 gotposixovlzip()
752 {
753 [ "$(which zip)" ] && gotposixovl "$1" "$2"
754 }
756 xfile()
757 {
758 [ "$(which $1)" ] && menuitem "$@"
759 }
761 cdfile()
762 {
763 gotcdfile "$1" && menuitem "$@"
764 }
766 isbzImage()
767 {
768 [ $(get 514 $file 4) -eq 1400005704 ] &&
769 [ $(($(get 529 $file 1) & 1)) -eq 1 ]
770 }
772 cdfilex()
773 {
774 gotcdfile "$1" && [ "$(which kexec)" ] && isbzImage && menuitem "$@"
775 }
777 cdfilef()
778 {
779 [ -e /sys/block/fd0 ] && cdfile "$@"
780 }
782 cdexe()
783 {
784 gotcdfile "$1" &&
785 [ $(get 0 $file 2>/dev/null || echo 0) -eq 23117 ] &&
786 menuitem "$@"
787 }
789 misspkg()
790 {
791 for i in zip kexec-tools posixovl cdrkit ; do
792 [ -d /var/lib/tazpkg/installed/$i/ ] && continue
793 [ "$1" != "install" ] && menuitem "$@" && return
794 tazpkg get-install $i
795 done
796 }
798 missing()
799 {
800 misspkg install
801 }
803 ishybrid()
804 {
805 [ $(get 510 $ISO) -eq 43605 ] || return
806 C=$((2048*$(get $(((17*2048) + 71)) $ISO 4)))
807 [ $(get $C $ISO 4) -eq 1 ] || return
808 [ $(get $(($C+30)) $ISO 4) -eq $((0x88AA55)) ] || return
809 C=$((2048*$(get $(($C+40)) $ISO 4)))
810 [ $(get $(($C+64)) $ISO 4) -eq 1886961915 ] && menuitem "$@"
811 }
813 isiso()
814 {
815 [ $(get 32769 $ISO 4) -eq 808469571 ] && menuitem "$@"
816 }
818 hastazboot()
819 {
820 [ $(get 0 $ISO) -eq 23117 ] && menuitem "$@"
821 }
823 burnable()
824 {
825 [ "$(sed '/Can wr.*1$/!d' /proc/sys/dev/cdrom/info)" ] && menuitem "$@"
826 }
828 blankable()
829 {
830 [ "$(sed '/Can wr.*RW.*1$/!d' /proc/sys/dev/cdrom/info)" ] && menuitem "$@"
831 }
833 burniso()
834 {
835 wodim -v speed=$(fgrep "drive speed" /proc/sys/dev/cdrom/info | cut -f3) \
836 -eject -multi "$ISO"
837 }
839 blankcd()
840 {
841 wodim -v -blank=fast
842 }
844 gotisomd5()
845 {
846 [ "$(which md5sum 2> /dev/null)" ] &&
847 [ $(get 0 $ISO) -eq 23117 ] &&
848 [ $(get 18 $ISO) -ne 0 ] && menuitem "$@"
849 }
851 isomd5()
852 {
853 dotwait "Checking iso image"
854 [ "$(ddq if=$ISO bs=2k skip=16 \
855 count=$(echo $(get 32848 $ISO 4)) | md5sum)" == \
856 "$(ddq if=$ISO bs=16 count=1 skip=2047 | od -N 16 -t x1 -An | \
857 sed 's/ //g') -" ] && echo "OK" || echo "ERROR"
858 echo -en "\rChecking iso hybrid boot..."
859 n=$(($(get 2 $ISO)-1+($(get 4 $ISO)-1)*512))
860 if [ $n -lt 40000 -a $n -gt 32768 ]; then
861 s=$(get 0 $ISO 2 $n | awk '{ i+= $0 } END { print i }')
862 [ $(((1+$s+$(get $(($n+1)) $ISO 1)) % 65536)) -eq 0 ] &&
863 echo "OK" || echo "ERROR"
864 fi
865 rm -f /tmp/wait
866 [ "$1" ] && return 0
867 echo -e "\rPress RETURN to continue."
868 read n
869 }
871 usbdev()
872 {
873 dotwait "Wait 5 seconds for USB devices"
874 sleep 5
875 rm -f /tmp/wait
876 DEV="$(grep -l 1 /sys/block/*/removable | \
877 sed 's|/sys/block/\(.*\)/removable|\1|')"
878 grep -qs 1 /sys/block/$DEV/ro && return
879 [ "$DEV" ] || return
880 cat > /tmp/dialog$$ <<EOT
881 $DIALOG --clear \
882 --title " Select your USB key " \
883 --menu "\nPlease select the USB key according to its known size.\n\n" \
884 0 0 0 \
885 $(for i in $DEV ; do
886 echo -n "/dev/$i \"$(($(cat /sys/block/$i/size)/2048))MB $(cat /sys/block/$i/device/model 2> /dev/null)\" "
887 done) \
889 EOT
890 exec 3>&1
891 device=$(. /tmp/dialog$$ 2>&1 1>&3)
892 rm -f /tmp/dialog$$
893 retval=$?
894 exec 3>&-
895 rm -f /tmp/dialog$$
896 [ $retval -eq 0 ]
897 }
899 tazusbmsg()
900 {
901 [ "$(which tazusb 2> /dev/null)" ] || return
902 echo "You should choose 'USB key read/write installation' to be
903 able to save the package updates or your own configuration and data files.\n\n"
904 }
906 usbbootkey()
907 {
908 if [ -b "$1" ]; then
909 device=$1
910 elif [ "$1" ]; then
911 echo "Invalid USB key device"
912 return 1
913 else
914 $DIALOG --clear \
915 --title " Create a USB boot key " \
916 --yes-label "Continue" --yesno \
917 "\nThe USB key will be used like a CD-ROM. You will not be able to write
918 any data on the boot partition.\n\n
919 An extra FAT32 partition will be created with the remaining free space.\n\n
920 $(tazusbmsg)Please plug your USB stick in now.\n
921 " 16 70
922 [ $? -eq 0 ] || return
923 usbdev || return
925 # perform dd in progress bar
926 max=$(($(stat -c %s $ISO)/2048))
927 i=0; ddq if=$ISO bs=1024k | (
928 while ddq bs=1024k count=1 ; do
929 i=$(($i + 1))
930 [ $i -gt $max ] && break
931 echo $((($i*100)/$max)) | dialog --gauge \
932 " The ISO image transfer can be long. Please wait..." \
933 6 70 0 > /dev/tty 2>&1
934 done ) > $device
935 fi
937 # partition + fat32 format for the remaining space
938 for p in 0 16; do
939 get $((450+$p)) $device 2 12 | xargs echo | {
940 read dx cx ol oh ll lh
941 [ $dx -eq $((0x3F17)) ] || continue
942 cx=$(($cx & 0xFF00))
943 ofs=$(($ll+($lh<<16)))
944 n=$(($(cat /sys/block/${device#/dev/}/size)-$ofs))
945 m=$(($cx+($n/8)))
946 [ $m -gt $((0x3FF00)) ] && m=$((0x3FF00))
947 m=$((($m & 0xFF00)+(($m>>16)<<6)))
948 words2bin 0 $((0x101+$cx)) 0x3F0B $((32+$m)) \
949 $ll $lh $(($n & 0xFFFF)) $(($n >> 16)) | \
950 ddq bs=1 seek=$((462-$p)) of=$device
951 if [ "$(which mkdosfs 2> /dev/null)" ]; then
952 losetup -o $((512*$ofs)) /dev/loop2 $device
953 mkdosfs -n "SLITAZ BOOT" /dev/loop2
954 words2bin $(($ofs & 0xFFFF)) $(($ofs >> 16)) | \
955 ddq bs=1 seek=28 of=/dev/loop2
956 sync
957 losetup -d /dev/loop2
958 fi
959 }
960 done
961 }
963 usbkey()
964 {
965 $DIALOG --clear \
966 --title " Create a SliTaz USB key " \
967 --yes-label "Continue" --yesno \
968 "\nUnlike a hard drive install, the filesystem is kept in a compressed
969 rootfs.gz. The filesystem is loaded entirely into memory upon boot.
970 This should increase responsiveness, protect the filesystem against
971 accidental corruption and reduce read/writes to the USB drive.
972 Once setup, the tazusb utility can rewrite the root filesystem
973 with any changes you have made since booting up,
974 giving the effective benefits of a hard drive install.\n\n
975 /home is mounted on boot using the UUID of your particular flash drive.
976 Unlike a device name, the UUID has the benefit of never changing from machine
977 to machine.\n\n
978 Please plug your USB stick in now.\n
979 " 19 70
980 [ $? -eq 0 ] || return
981 usbdev || return
982 exec 3>&1
983 format=`$DIALOG --clear \
984 --title " Select the filesystem " \
985 --radiolist "\nPlease select the filesystem type to create.\n\n\
986 The filesystem creation will erase all the data \
987 in the USB key." 14 70 4 \
988 "none" "Do not erase the USB key" on \
989 "ext3" "Ext3 journaling filesystem" off \
990 "ext2" "Ext2 filesystem" off \
991 "fat32" "Windows FAT32 filesystem" off \
992 2>&1 1>&3`
993 retval=$?
994 exec 3>&-
995 [ $retval -eq 0 ] || return
996 [ "$format" != "none" ] && tazusb format $device "SliTaz" $format
997 tazusb gen-iso2usb $ISO $device
998 }
1000 dokexec()
1002 kexec -l $file || return
1003 quit "kexec -e"
1006 runmemtest()
1008 gotcdfile 'memtest*' && dokexec
1011 runpxe()
1013 gotcdfile '?pxe' && dokexec
1016 flavdata()
1018 [ $(get 1024 $ISO) -eq 35615 ] && n=2 || n=$((1+$(get 417 $ISO 1)))
1019 dd if=$ISO bs=512 skip=$n count=20 2>/dev/null | zcat 2>/dev/null
1022 hasflavinfo()
1024 [ "$(flavdata | dd bs=1 count=8 2> /dev/null | strings)" == \
1025 "07070100" ] && menuitem "$@"
1028 showfavinfo()
1030 mkdir -p /tmp/data
1031 flavdata | ( cd /tmp/data ; cpio -i )
1032 file=/tmp/data/info
1033 cat /tmp/data/*desc > $file
1034 for i in /tmp/data/*list* ; do
1035 echo "=== extra ${i#*list} files"
1036 cat $i
1037 done >> $file
1038 if [ "$1" ]; then
1039 cat $file
1040 else
1041 $DIALOG --clear \
1042 --title " Flavor info " \
1043 --textbox $file 0 0
1044 fi
1045 rm -rf /tmp/data
1048 if [ "$1" == "--build" ]; then #install-begin
1049 uuencode -m - < ifmem.bin | sed -e '/^ifmemcode$/r/dev/stdin' \
1050 -e '/^ifmemcode$/d' -i $0
1051 uuencode -m - < bootloader.bin | sed -e '/^bootloader$/r/dev/stdin' \
1052 -e '/^bootloader$/d' -e '/install-begin$/,/install-end$/d' -i $0
1053 exit
1054 fi #install-end
1055 parse_isolinux()
1057 awk 'BEGIN { IGNORECASE=1 }
1058 function multi(n)
1060 auto=$n
1061 for (--n; n < NF; n+=2) {
1062 s=$n
1063 if (s ~ /M$/) s = substr(s,0,length(s)-1)
1064 else s /= 1024
1065 sizes=int(s) " " sizes
1067 next
1070 if ($1 == "LABEL") {
1071 label=$2
1072 if (auto == "") auto=label
1074 if ($1 == "KERNEL" || $1 == "COM32") kernel[label]=$2
1075 if ($1 == "INITRD") initrd[label]=$2
1076 if ($1 == "APPEND") {
1077 i=2
1078 if (kernel[label] ~ "ifmem.c32") multi(3)
1079 if (kernel[label] ~ "c32box.c32") {
1080 if ($2 == "linux") { kernel[label]=$3; i=4 }
1081 if ($2 == "ifmem") multi(4)
1083 if (kernel[label] ~ "ifcpu64.c32") { auto=$4; next }
1084 while (i <= NF) {
1085 if ($i ~ "^initrd=") initrd[label]=substr($i,8)
1086 else cmdline[label]=cmdline[label] " " $i
1087 i++
1091 END {
1092 print "KERNEL=\"" kernel[auto] "\""
1093 print "INITRD=\"" initrd[auto] "\""
1094 print "CMDLINE=\"" substr(cmdline[auto],2) "\""
1095 print "SIZES=\"" sizes "\""
1096 }'
1099 locase()
1101 echo "$1" | tr [A-Z] [a-z]
1104 ifmemcode()
1106 uudecode <<EOT
1107 ifmemcode
1108 EOT
1111 floppyset()
1113 gotcdfile isolinux.cfg
1114 parse_isolinux < $file > /tmp/var$$
1115 . /tmp/var$$
1116 for i in $media/$KERNEL $(dirname $file)/$KERNEL $media/$(locase $KERNEL) \
1117 $(dirname $file)/$(locase $KERNEL); do
1118 [ -s $i ] && KERNEL=$i && break
1119 done
1120 rm -f /tmp/var$$
1121 [ $(get 514 $KERNEL 4) -eq 1400005704 ] || return
1122 n=$(($(get 497 $KERNEL 1)+1))
1123 ddq bs=512 count=$n if=$KERNEL of=/tmp/fd$$
1124 uudecode <<EOT | ddq of=/tmp/fd$$ conv=notrunc
1125 bootloader
1126 EOT
1127 pos=$(($n*512))
1128 if [ -n "$CMDLINE" ]; then
1129 echo -n "$CMDLINE" | ddq bs=512 count=1 conv=sync >> /tmp/fd$$
1130 bytes2bin $n | ddq conv=notrunc \
1131 bs=1 seek=497 count=1 of=/tmp/fd$$
1132 words2bin $pos | ddq conv=notrunc \
1133 bs=1 seek=34 count=2 of=/tmp/fd$$
1134 [ $(get 518 $KERNEL 4) -ge 514 ] &&
1135 words2bin 32768 9 | ddq conv=notrunc \
1136 bs=1 seek=552 count=4 of=/tmp/fd$$
1137 fi
1138 syssize=$(echo $(get 500 /tmp/fd$$ 4))
1139 ddq bs=512 skip=$n if=$KERNEL | cat - /dev/zero | \
1140 ddq bs=512 count=$((($syssize+31)/32)) conv=sync >> /tmp/fd$$
1141 base=$(stat -c %s /tmp/fd$$)
1142 len=
1143 if [ "$INITRD" ]; then
1144 l=0
1145 for i in ${INITRD//,/ }; do
1146 for j in $media/$i $(dirname $KERNEL)/$i $media/$(locase $i) \
1147 $(dirname $KERNEL)/$(locase $i); do
1148 [ -s $j ] && i=$j && break
1149 done
1150 ddq if=$i >> /tmp/fd$$
1151 l=$(($l+$(stat -c %s $i)))
1152 r=$((4 - ($l % 4)))
1153 if [ $r -ne 4 ]; then
1154 ddq if=/dev/zero bs=1 count=$r >> /tmp/fd$$
1155 l=$(($l + $r))
1156 fi
1157 case "$i:$INITRD" in
1158 *rootfs.gz:*rootfs.gz,*) continue # loram
1159 esac
1160 len="$len $l"; l=0
1161 done
1162 rdadrs=${RDADRS:-$(((($syssize*16)+0x1F0000) & -4096))}
1163 words2bin $(($rdadrs & 0xFFFF)) $(($rdadrs >> 16)) | ddq \
1164 conv=notrunc bs=1 seek=536 count=4 of=/tmp/fd$$
1165 fi
1166 n=$(echo $len | wc -w)
1167 if [ $((494 - $(get 494 /tmp/fd$$))) -ge $(($n * 4)) ]; then
1168 i=$(($(get 494 /tmp/fd$$)))
1169 bytes2bin $(($i + ($n*4) - 256)) | ddq bs=1 conv=notrunc \
1170 seek=496 count=1 of=/tmp/fd$$
1171 else
1172 i=$(($pos + 0x1FC - ($n*4)))
1173 bytes2bin $(($i % 256)) $((i / 256)) 252 | ddq bs=1 \
1174 conv=notrunc seek=494 count=3 of=/tmp/fd$$
1175 s=$(($i - 2*$(echo "$SIZES" | wc -w)))
1176 p=$(($s - $(ifmemcode | wc -c)))
1177 ifmemcode | ddq bs=1 conv=notrunc seek=$p of=/tmp/fd$$
1178 words2bin $SIZES | ddq bs=1 conv=notrunc seek=$s of=/tmp/fd$$
1179 bytes2bin 154 $(($p%256)) $(($p/256)) 0 144 | \
1180 ddq bs=1 conv=notrunc seek=60 of=/tmp/fd$$
1181 fi
1182 for r in $len ; do
1183 words2bin $(($r & 0xFFFF)) $(($r >> 16)) | ddq conv=notrunc \
1184 bs=1 seek=$i count=4 of=/tmp/fd$$
1185 i=$(($i + 4))
1186 done
1187 split -b 1440k /tmp/fd$$ fd$$
1188 rm -f /tmp/fd$$
1189 n=1; i=0; r=0
1190 set -- $len
1191 ls fd$$* | while read file ; do
1192 if [ $i -gt $(($1+$base)) ]; then
1193 shift
1194 r=$(($r+100)); n=0; i=0; base=0
1195 fi
1196 ddq of=$file bs=18k seek=80 count=0
1197 i=$(($i+1474560))
1198 printf "mv %s fd%03d.img\n" $file $(($r+$n))
1199 n=$(($n+1))
1200 done | sh
1201 ls fd???.img
1204 quit()
1206 umount -d $media
1207 rmdir $media
1208 ${1:-exit}
1211 ISO="${1:-/dev/null}"
1212 [ -z "$(isiso 2> /dev/null)" ] && echo "Usage : $0 file.iso" && exit 1
1213 media=/tmp/madia$$
1214 mkdir -p $media
1215 mount -o loop,ro $ISO $media
1217 if [ "$2" == "list" ]; then
1218 sed '/^\$(.*") \\/!d;s/^\$(\(.*\)").*/\1"/' $0 | while read line; do
1219 eval $line
1220 echo
1221 done | sed '/^$/d;/"usbkey"/d'
1222 quit
1223 fi
1224 if grep -q "^$2()" $0; then
1225 exe=$2
1226 shift 2
1227 if [ -n "$(eval $(grep "\"$exe\"" $0 | sed \
1228 '/^\$/!d;s/.(\(.*\)[\t ]*".*"[\t ]*".*/\1/'))" ]; then
1229 grep "\"$exe\"" $0 | sed '/^\$/!d;s/.*"[\t ]*"\(.*\)".*/\1/'
1230 echo ----
1231 $exe "$@"
1232 fi
1233 quit
1234 fi
1236 while true; do
1237 cat > /tmp/dialog$$ <<EOT
1238 $DIALOG --clear \
1239 --title " $(basename $ISO) $(stat -c %y $media/. | sed 's/ .*//') " \
1240 --menu "" -2 70 0 \
1241 $(cdfile 'README*' "readme" "Show the README file") \
1242 $(gotisomd5 "isomd5" "Check the ISO image") \
1243 $(cdfile 'md5sum*' "md5" "Check the ISO files") \
1244 $(cdfile 'sha*sum*' "sha" "Check the ISO files") \
1245 $(cdfilex boot/bzImage "bootiso" "Boot the ISO image") \
1246 $(burnable "burniso" "Burn the ISO image") \
1247 $(blankable "blankcd" "Blank the CD/DVD") \
1248 $(gotposixovl "install" "Hard disk installation (UMSDOS way)") \
1249 $(gotposixovl "installtaz" "Hard disk installation (TAZUSB way)") \
1250 $(gotposixovlzip "inst2zip" "ZIP installation archive (UMSDOS way)") \
1251 $(gotposixovlzip "insttaz2zip" "ZIP installation archive (TAZUSB way)") \
1252 $(xfile tazusb "usbkey" "USB key read/write installation") \
1253 $(ishybrid "usbbootkey" "USB boot key (read only)") \
1254 $(hasflavinfo "showfavinfo" "Show flavor extra info") \
1255 $(cdfile isolinux.cfg "floppyset" "Boot floppy set") \
1256 $(hastazboot "tazboot" "Get tazboot.exe Linux loader") \
1257 $(cdexe boot/bzImage "bzimage" "Get linux DOS/EXE file") \
1258 $(cdexe 'memtest*' "memtest" "Get Memtest86 DOS/EXE file") \
1259 $(cdfilef 'memtest*' "fdmemtest" "Create a Memtest86 boot floppy") \
1260 $(cdfilex 'memtest*' "runmemtest" "Start Memtest86") \
1261 $(cdexe '?pxe' "pxe" "Get SliTaz Web boot DOS/EXE utility") \
1262 $(cdfilef '?pxe' "fdpxe" "Create a SliTaz Web boot floppy") \
1263 $(cdfilex '?pxe' "runpxe" "Start the SliTaz Web boot utility") \
1264 $(misspkg "missing" "Install packages to get more options") \
1265 $(menuitem "quit" "Quit this utility")
1266 EOT
1267 exec 3>&1
1268 value=$(. /tmp/dialog$$ 2>&1 1>&3)
1269 retval=$?
1270 exec 3>&-
1271 rm -f /tmp/dialog$$
1272 [ $retval -eq 0 ] || break
1273 $value
1274 done